#
# Conditional build:
%bcond_without	tcmalloc	# tcmalloc allocator

%ifarch x32
%undefine       with_tcmalloc
%endif
Summary:	Pound - reverse-proxy and load-balancer
Summary(pl.UTF-8):	Pound - odwrotne proxy i load-balancer
Name:		pound
Version:	3.0.2
Release:	3
License:	GPL v3
Group:		Networking/Daemons
Source0:	http://www.apsis.ch/pound/Pound-%{version}.tgz
# Source0-md5:	c0f5af4cd6aa184c00f4848ae1c4536a
Source1:	%{name}.yaml
Source2:	%{name}.init
Source3:	%{name}.sysconfig
Source5:	%{name}.tmpfiles
Patch0:		tcmalloc.patch
Patch1:		pound-man.patch
Patch2:		mbedtls3.patch
URL:		https://www.apsis.ch/pound.html
BuildRequires:	cmake >= 3.0
%{?with_tcmalloc:BuildRequires:	libtcmalloc-devel}
BuildRequires:	mbedtls-devel
BuildRequires:	nanomsg-devel
BuildRequires:	pcre2-8-devel
BuildRequires:	pcre2-posix-devel
BuildRequires:	rpmbuild(macros) >= 1.644
BuildRequires:	yaml-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	pcre >= 7.8
Requires:	rc-scripts
Provides:	group(pound)
Provides:	user(pound)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/pound

%description
The Pound program is a reverse proxy, load balancer and HTTPS
front-end for Web server(s). Pound was developped to enable
distributing the load among several Web-servers and to allow for a
convenient SSL wrapper for those Web servers that do not offer it
natively. Pound is distributed under the GPL - no warranty, it's free
to use, copy and give away.

%description -l pl.UTF-8
Program Pound jest odwrotnym proxy, load-balancerem i interfejsem
HTTPS do serwera(ów) WWW. Pount został stworzony by pozwolić na
rozdzielenie obciążenia na kilka serwerów WWW i pozwolić na wygodne
opakowanie SSL-em tych serwerów, które same nie obsługują SSL. Pound
jest rozpowszechniany na licencji GPL - bez gwarancji, z możliwością
swobodnego używania, kopiowania i rozdawania.

%prep
%setup -q -n Pound-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
install -d build
cd build
%cmake .. \
	%{?with_tcmalloc:-DWANT_TCMALLOC:BOOL=ON}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man8,%{_sysconfdir},/etc/{sysconfig,rc.d/init.d}} \
	$RPM_BUILD_ROOT/var/run/%{name} \
	$RPM_BUILD_ROOT%{systemdtmpfilesdir}

install -p build/pound $RPM_BUILD_ROOT%{_sbindir}
cp -p man/pound.8  $RPM_BUILD_ROOT%{_mandir}/man8
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}
install -p %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
cp -p %{SOURCE5} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/%{name}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 200 %{name}
%useradd -u 200 -d /var/lib/%{name} -g %{name} -c "Pound Daemon" %{name}

%post
/sbin/chkconfig --add %{name}
%service %{name} restart "Pound Daemon"

%preun
if [ "$1" = "0" ]; then
	%service %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = "0" ]; then
	%userremove %{name}
	%groupremove %{name}
fi

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_sbindir}/pound
%dir %{_sysconfdir}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pound.yaml
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%{_mandir}/man8/pound.8*
%{systemdtmpfilesdir}/%{name}.conf
%dir /var/run/%{name}
%changelog
* Sat Apr 08 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/pound.git;a=log;h=master

* Sat Apr 08 2023 Jakub Bogusz <qboosh@pld-linux.org> 569e65c
- release 3 (mbedtls 3.4)

* Sat Jan 14 2023 Jakub Bogusz <qboosh@pld-linux.org> f8f3fdb
- updated dependencies, release 2 (nanomsg soname change)

* Tue Apr 05 2022 Jan Rękorajski <baggins@pld-linux.org> 875c35e
- up to 3.0.2, fix building with mbedtls 3

* Mon Apr 04 2022 Jan Rękorajski <baggins@pld-linux.org> d6341e1
- Release 2 (by relup.sh)

* Mon Oct 25 2021 Jan Rękorajski <baggins@pld-linux.org> 6477195
- updated to 3.0.1, WARNING: new config syntax and location

* Mon Oct 04 2021 Jan Rękorajski <baggins@pld-linux.org> 4eb5032
- rediff patches

* Sun Sep 30 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 2f08aa3
- up to 2.8 and add openssl 1.1.1 patch

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 1cc2fb9
- release 3 (by relup.sh)

* Mon Jul 25 2016 Elan Ruusamäe <glen@delfi.ee> fe5246d
- update defaults

* Mon Feb 29 2016 Elan Ruusamäe <glen@delfi.ee> a63d202
- better https defaults

* Sun May 10 2015 Jan Rękorajski <baggins@pld-linux.org> 95d418a
- disable tcmalloc usage on x32
- rel 2

* Wed Apr 29 2015 Elan Ruusamäe <glen@delfi.ee> 6444554
- up to 2.7 (January 26, 2015)

* Mon Apr 28 2014 Elan Ruusamäe <glen@delfi.ee> 7c4d13b
- ensure consistent build by enforcing options, BR tcmalloc

* Mon Apr 28 2014 Elan Ruusamäe <glen@delfi.ee> e6ba7a2
- rebuild with 6144 bufsize

* Wed Apr 17 2013 Jan Rękorajski <baggins@pld-linux.org> d307307
- release 6 (by relup.sh)

* Mon Apr 01 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 9d7a4e2
- release 5 (by relup.sh)

* Fri Feb 22 2013 Elan Ruusamäe <glen@delfi.ee> 361f3ee
- GPL version; rel 4

* Thu Nov 15 2012 Elan Ruusamäe <glen@delfi.ee> c8a5f4a
- rel 3, to rebuild with 4k BUFSIZ

* Thu Nov 15 2012 Elan Ruusamäe <glen@delfi.ee> be91c8d
- do not decrease buffer size smaller than upstream

* Thu Nov 15 2012 Elan Ruusamäe <glen@delfi.ee> 0453b2b
- systemd macros

